org.apache.lucene.util

## Class BytesRefComparator

- java.lang.Object
- - org.apache.lucene.util.BytesRefComparator

All Implemented Interfaces:
  Comparator<BytesRef>

    public abstract class BytesRefComparator
    extends Object
    implements Comparator<BytesRef>

Specialized `BytesRef` comparator that `FixedLengthBytesRefArray.iterator(Comparator)` has optimizations for.

NOTE: This API is for internal purposes only and might change in incompatible ways in the next release.

### Constructor Summary

Constructors
`protected` `BytesRefComparator(int comparedBytesCount)` Sole constructor.

### Method Summary

All Methods Instance Methods Abstract Methods Concrete Methods
`protected abstract int` `byteAt(BytesRef ref, int i)` Return the unsigned byte to use for comparison at index `i`, or `-1` if all bytes that are useful for comparisons are exhausted.
`int` `compare(BytesRef o1, BytesRef o2)`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface java.util.Comparator

`comparing, comparing, comparingDouble, comparingInt, comparingLong, equals, naturalOrder, nullsFirst, nullsLast, reversed, reverseOrder, thenComparing, thenComparing, thenComparing, thenComparingDouble, thenComparingInt, thenComparingLong`

### Constructor Detail

#### BytesRefComparator

    protected BytesRefComparator(int comparedBytesCount)

Sole constructor.

Parameters:
  `comparedBytesCount` - the maximum number of bytes to compare.

### Method Detail

#### byteAt

    protected abstract int byteAt(BytesRef ref,
                                  int i)

Return the unsigned byte to use for comparison at index `i`, or `-1` if all bytes that are useful for comparisons are exhausted. This may only be called with a value of `i` between `0` included and `comparedBytesCount` excluded.

#### compare

    public int compare(BytesRef o1,
                       BytesRef o2)

Specified by:
  `compare` in interface `Comparator<BytesRef>`